#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <time.h>

#define BROJ_RADNIKA 2

#define BROJ_DELOVA 5
pthread_mutex_t mutex;
pthread_cond_t cond;

int brojacDelova=0;
int brNaSusenju=0;

int brojOfarbanih[BROJ_DELOVA];
int brojFarbanja[BROJ_RADNIKA];
int naSusenju[5];
int cekaFarbanje[BROJ_DELOVA];

void *farbanje(void *id)
{ //deo koji stize
	long tid=(long)id;
	
	while(1)
	{
		int vremeStizanja=random()%10;
		sleep(vremeStizanja+1);
		int p=random()%21+1;//povrsina
		int k=random()%5+1;//koliko slojeva farbe je potrebno

		brojacDelova++;

		printf("Radnik %ld: Doneo sam deo %d .(Povrsina %d, br slojeva %d)\n",tid,brojacDelova,p,k);

	//while(brojOfarbanih[brojacDelova]<k)
	//	{
			pthread_mutex_lock(&mutex);
			printf("Radnik %ld: Farbam deo %d u sloju %d/%d\n",tid,brojacDelova,++brojOfarbanih[brojacDelova],k);
			sleep(2);
			pthread_mutex_unlock(&mutex);
		
		
		//deljeni resurs je susara
		pthread_mutex_lock(&mutex);
			while(brNaSusenju>5)
				pthread_cond_wait(&cond,&mutex);
			brNaSusenju++;
			printf(" Deo %d je na susenju %d/%d\n",brojacDelova,brojOfarbanih[brojacDelova],k);
			int vremeSusenja=random()%5;
			//susi se
			sleep(vremeSusenja);
		pthread_mutex_unlock(&mutex);
		//printf("Radnik %ld:Deo %d se osusio\n %d/%d\n",tid,brojacDelova,i,k);
		
		pthread_mutex_lock(&mutex);
		if(brojOfarbanih[brojacDelova]==k)
		{
			printf("%d se osusio\n",brojacDelova);
			//brojacDelova++;
		}

			brNaSusenju--;
		pthread_mutex_unlock(&mutex);
	
		
		
		//provera da li je nestalo delova
			pthread_mutex_lock(&mutex);
				if(brojacDelova>BROJ_DELOVA)
				{
					pthread_cond_broadcast(&cond);
					printf("Gotov posao\n");
					break;
					
				}
			pthread_mutex_unlock(&mutex);
		
		//}
	}
	pthread_exit(NULL);
	
}
int main()
{
	pthread_t threads[BROJ_RADNIKA];
	pthread_attr_t attr;
	
	pthread_attr_setdetachstate(&attr,PTHREAD_CREATE_JOINABLE);
	pthread_mutex_init(&mutex,NULL);
	pthread_cond_init(&cond,NULL);
	for(int i=0;i<BROJ_DELOVA;i++)
		brojOfarbanih[i]=0;
	for(long i=0;i<BROJ_RADNIKA;i++)
		pthread_create(&threads[i],NULL,farbanje,(void *)i);
	for(long i=0;i<BROJ_RADNIKA;i++)
		pthread_join(threads[i],NULL);
		
		
	pthread_mutex_destroy(&mutex);
	pthread_attr_destroy(&attr);
	pthread_exit(NULL);
	
}




