#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include<time.h>
#include<unistd.h>

#define KAPACITET 3
#define BROJ_NITI 10
#define SLOBODAN 1
#define ZAUZET 0

pthread_mutex_t mutex=PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond=PTHREAD_COND_INITIALIZER;



int susara=0;
int brojDelova=0;
int radnici[2]={SLOBODAN,SLOBODAN};

void *deo(void* arg){
    long id=(long)arg;
    int vreme=rand()%5+1;
    int povrsina=rand()%10+1;
    int brojSlojeva=rand()%5+1;
    int brojacSLojeva=0;

    printf("Deo %ld stize posle %dsec. Povrsina: %d, broj slojeva: %d\n",id,vreme,povrsina,brojSlojeva);
    
    while(1){

        pthread_mutex_lock(&mutex);
        // while(brojDelova>=KAPACITET){
        //     pthread_cond_wait(&cond,&mutex);
        // }
        brojDelova++;
        pthread_mutex_unlock(&mutex);
        
        
        if(radnici[0]==SLOBODAN){
            pthread_mutex_lock(&mutex);
            brojDelova--;
            brojacSLojeva++;
            radnici[0]=ZAUZET;
            pthread_mutex_unlock(&mutex);
            printf("Radnik 0 farba deo %ld\n",id);
            sleep(3);

            pthread_mutex_lock(&mutex);
            radnici[0]=SLOBODAN;
            printf("Radnik 0 slobodan\n");
            pthread_mutex_unlock(&mutex);

        }
        else if(radnici[1]==SLOBODAN){
            pthread_mutex_lock(&mutex);
            brojDelova--;
            brojacSLojeva++;
            radnici[1]=ZAUZET;
            pthread_mutex_unlock(&mutex);

            printf("Radnik 1 farba deo %ld\n",id);
            sleep(3);

            pthread_mutex_lock(&mutex);
            radnici[0]=SLOBODAN;
            printf("Radnik 1 slobodan\n");
            pthread_mutex_unlock(&mutex);
        }
        // else if(radnici[0]==ZAUZET && radnici[1]==ZAUZET){
        //     printf("Oba radnika su zauzeta\n");
        // }
        
        
        // printf("Radnik farba deo %ld\n",id);
        // sleep(3);
        printf("Radnik ofarbao deo %ld, naneo sloj %d salje ga u susaru\n",id,brojacSLojeva);
        
        if(susara<KAPACITET){
            pthread_mutex_lock(&mutex);
            susara++;
            pthread_mutex_unlock(&mutex);
        }
        printf("Deo %ld se susi\n",id);
        sleep(3);
        pthread_mutex_lock(&mutex);
        susara--;
        pthread_mutex_unlock(&mutex);
        printf("Deo %ld je napustio susaru\n",id);
        
        if(brojacSLojeva==brojSlojeva){
            printf("-> Na deo %ld su naneti svi slojevi\n",id);
            break;
        }
    }
    


    pthread_exit(NULL);
}



int main(){
    srand(time(NULL));
    pthread_t niti[BROJ_NITI];

    for(long i=0;i<BROJ_NITI;i++){
        pthread_create(&niti[i],NULL,deo,(void*)i);
    }

    for(long i=0;i<BROJ_NITI;i++){
        pthread_join(niti[i],NULL);
    }
    
    
    return 0;

}
