#include<stdio.h>
#include<pthread.h>
#include<stdlib.h>
#include<unistd.h>

#define N 5
#define kapacitet_susare 3
#define vreme_susare 5

int radnik[2];
int popunjenost_susare=0;
pthread_mutex_t mutex_radnik,mutex_susara;
pthread_cond_t radnik_condition,susara_condition;

void *process(void * args)
{
    int radnik_index=0;
    int *id_arg=(int*)args;
    int id=*id_arg;
    int povrsina=random()%5+1;
    int slojevi=random()%5+1;
    int vreme_da_stigne=random()%5;
    sleep(vreme_da_stigne);
    printf("Stigao je deo %d, %d povrsine, %d slojeva\n",id,povrsina,slojevi);
    
    for(int i=0;i<slojevi;i++)
    {
        pthread_mutex_lock(&mutex_radnik);
        while(radnik[0]&radnik[1]) pthread_cond_wait(&radnik_condition,&mutex_radnik);
        if(radnik[0]==0)
        {
            radnik_index=0;
            radnik[radnik_index]=1;
        }
        else if(radnik[1]==0)
        {
            radnik_index=1;
            radnik[radnik_index]=1;
        }
        printf("radnik index %d, sloj %d\n",radnik_index,i);
        pthread_mutex_unlock(&mutex_radnik);
      
        printf("radnik %d radi na %d,  sloj :%d\n",radnik_index,id,i);
        sleep(povrsina);  // radnik radi 

        pthread_mutex_lock(&mutex_radnik);
        printf("radnik %d zavrsio\n",radnik_index);
        radnik[radnik_index]=0;//radnik zavrsio, oslobodi radnika
        pthread_mutex_unlock(&mutex_radnik);

        pthread_cond_broadcast(&radnik_condition); //javi ostalima da postoji mesto za radnika;
     
        
        pthread_mutex_lock(&mutex_susara);
        while(popunjenost_susare>=kapacitet_susare) pthread_cond_wait(&susara_condition,&mutex_susara);
        popunjenost_susare+=1;
        pthread_mutex_unlock(&mutex_susara);
        printf("radi susara, popunjenost %d\n",popunjenost_susare);
        sleep(vreme_susare);// radi susara;

        pthread_mutex_lock(&mutex_susara);
        popunjenost_susare-=1; //oslobodi susaru
        printf("oslobadjanje susare, popunjenost %d\n",popunjenost_susare);
        pthread_mutex_unlock(&mutex_susara);

        pthread_cond_broadcast(&susara_condition); //javi ostalima da postoji mesto za susaru;
    }
    printf("obrada dela id=%d je zavrsena\n",id);


  
}

int main()
{
    radnik[0]=0;
    radnik[1]=0;
    pthread_t thread[N];
    for(int i=0;i<N;i++)
    {
        srand((time_t)i);
        pthread_create(thread+i,NULL,process,(void*)&i);
    }
    for(int i=0;i<N;i++)
    {
        pthread_join(thread[i],NULL);
    }
    
   
    return 0;
}