#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include<unistd.h>

#define N 10 // broj delova
#define X 3 // kapacitet susare
// #define PRAZNA 0
// #define PUNA 1
// #define SLOBODAN 0
// #define RADI 1

// int radnici[2] = {SLOBODAN, SLOBODAN};
int radnici = 0;
int susara = 0;

pthread_mutex_t mutex;
// pthread_mutex_t mutexSusenje;
pthread_cond_t condFarbanje;
pthread_cond_t condSusenje;

void *farbaj(void *arg)
{
    long id = (long) arg;
    int p = rand() % 6 + 1; //povrsina
    int k = rand() % 4 + 1; //broj slojeva
    
    sleep(rand() % 5);
    printf("\tU farbaru stize deo %ld.\n", id);

    while (k > 0)
    {
        printf("Deo %ld ceka farbanje, povrsina: %d, preostalo slojeva: %d.\n", id, p, k);
        pthread_mutex_lock(&mutex);
        while (radnici >= 2) pthread_cond_wait(&condFarbanje, &mutex);

        radnici ++;

        pthread_mutex_unlock(&mutex);
        
        printf("Deo %ld se farba.\n", id);
        sleep(p);
        
        pthread_mutex_lock(&mutex);
        radnici --;
        if (radnici == 1)
            pthread_cond_broadcast(&condFarbanje);
        pthread_mutex_unlock(&mutex);

        // printf("Deo %ld je ofarban.\n", id);
        printf("Deo %ld je ofarban, ceka susenje.\n", id);

        /*==============SUSENJE==============*/
        // printf("Deo %ld ceka susenje, povrsina %d\n", id, p);
        pthread_mutex_lock(&mutex);
        while (susara >= X) pthread_cond_wait(&condSusenje, &mutex);

        susara ++;

        pthread_mutex_unlock(&mutex);

        printf("Deo %ld se susi.\n", id);
        sleep(p);

        printf("Deo %ld se osusio.\n", id);

        pthread_mutex_lock(&mutex);
        
        susara --;
        if (susara < X)
            pthread_cond_broadcast(&condSusenje);

        pthread_mutex_unlock(&mutex);

        k --;
    }

    printf("\tGOTOV: Deo %ld je gotov.\n", id);
}

int main()
{
    pthread_t t[N];
    pthread_mutex_init(&mutex, NULL);
    // pthread_mutex_init(&mutexSusenje, NULL);
    pthread_cond_init(&condFarbanje, NULL);
    pthread_cond_init(&condSusenje, NULL);

    for (long i = 0; i < N; i ++)
        pthread_create(&t[i], NULL, farbaj, (void *) i);

    for (int i = 0; i < N; i ++)
        pthread_join(t[i], NULL);

    return 0;
}
