#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <time.h>

#define Xmesta 3

int susenjeMesta = 0;

int t_i;

int p_i;

int k_i;

int ofarban = 0;
int fiksnaKolicinaFarbe = 40;

int i;

pthread_mutex_t mux;
pthread_mutex_t mux_s;

pthread_cond_t condNemaFarbe;
pthread_cond_t condSusenje;
// svaki deo je jedan tred

void *work(void *arg){
    
    long ID = (long)arg;
    srand(time(NULL)+(int)ID);
/*
    Dolazi deo, ulazi u kriticnu
*/    
    while(ofarban >= 0){    
        printf("OFARBAN : %d, DEO: %d\n", ofarban, i);
        pthread_mutex_lock(&mux);
        t_i = rand() % 20;

        i++;
        printf("I: %d\n", i);

        p_i = rand()%5+1;
        k_i = rand()%5+1;

        printf("Moja povrsina je %d\n", p_i);
        printf("Kolicina farbe koju imam za farbanje je %d\n", k_i);

        while(p_i > k_i){
            printf("Nemam dovoljno farbe da pokrijem povrsinu!\n");
            pthread_cond_wait(&condNemaFarbe, &mux);
        }

        
        pthread_mutex_unlock(&mux);
        printf("%ld: Mogu da otpocnem farbanje dela %d!\n", ID, i);
        
        sleep(rand()%4);
        ofarban++;
        
        
        printf("%ld: Zavrsio sam farbanje dela: %d\n", ID, i);
        printf("Trenutno ofarbanih: %d\n",ofarban);
        
        if(ofarban > 0){
            printf("Obavestavam da je deo %d zavrsen i da moze na susenje!\n", i);
            pthread_cond_signal(&condSusenje);
        }
        
    /*
        Trenutak kada treba da se pozove susara..
    */

        sleep(rand()%15);
    }

    return NULL;
}
void *workS(void *arg){

    long ID = (long)arg;
    printf("Susara: %ld\n", ID);
    
    pthread_mutex_lock(&mux);
    if(k_i < p_i){
         k_i = fiksnaKolicinaFarbe;
         pthread_cond_signal(&condNemaFarbe);
    }
    
    printf("Dopuna farbe: %d kolicina farbe\n", k_i);

    pthread_mutex_unlock(&mux);
        
/*
    Daj jednom signal da je farba dopunjena, nemoj svima!
*/
     pthread_mutex_lock(&mux);
        
     while(susenjeMesta > Xmesta){
        printf("Nema mesta na susenju!\n");
        pthread_cond_wait(&condSusenje, &mux); 
     }
     susenjeMesta++;   
     printf("Otpocinjem susenje dela: %d\n", ofarban);
     sleep(rand()%5+1);
    
     
     ofarban--;
     susenjeMesta--;
     
     printf("Susenje je zavrseno za deo %d.\n", i);
    

     printf("Trenutan broj mesta u susari je %d\n", susenjeMesta);
        
    pthread_mutex_unlock(&mux);

    if(susenjeMesta > Xmesta){
        susenjeMesta = 0;
        printf("Oslobodjena su sva mesta!\n");
        pthread_cond_broadcast(&condSusenje);
    }

}

int main(){

    pthread_t pth[2];
    pthread_t pth_s;

    pthread_mutex_init(&mux, NULL);

    pthread_cond_init(&condNemaFarbe, NULL);
    pthread_cond_init(&condSusenje, NULL);

    for(int i = 0; i < 3; i++){
        if(i == 2){
            pthread_create(&pth_s, NULL, workS, (i+1));
        }else{
            pthread_create(&pth[i], NULL, work, (i+1));
        }
    }

    for(int i = 0; i < 2; i++){
        if(i == 2){
            pthread_join(pth_s, NULL);
        }else{
            pthread_join(pth[i], NULL);
        }
    }

    pthread_mutex_destroy(&mux);
    pthread_cond_destroy(&condNemaFarbe);
    pthread_cond_destroy(&condSusenje);

    
    return 0;

    
}
// gcc -o pthread pthread_01.c -pthread