#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <time.h>
#define X 10
#define N 10
#define S 2

pthread_mutex_t mutexFarbanje, mutexSusenje;
pthread_cond_t condFarbanje, condSusenje;

int br_delova_u_susari = 0;
int br_zauzetih_radnika = 0;

void *farbanje(void *arg)
{
    int p = rand()%5+1;
    int k = rand()%5+1;
    int t = rand()%5;
    long i = (long) arg;
    sleep(t);
    printf("Ja sam deo %ld, moja povrsina je %d, potrebno je naneti %d slojeva farbe.\n",i,p,k);
    for(int j=0; j<k; j++)
    {
        pthread_mutex_lock(&mutexFarbanje);
        while(br_zauzetih_radnika > 1) pthread_cond_wait(&condFarbanje, &mutexFarbanje);
        br_zauzetih_radnika++;
        pthread_mutex_unlock(&mutexFarbanje);

        printf("Ja sam deo %ld, krecem sa farbanjem sloja %d\n", i, j);
        sleep(p);
        printf("Ja sam deo %ld, zavrsio sam sa farbanjem sloja %d\n", i, j);

        pthread_mutex_lock(&mutexFarbanje);
        br_zauzetih_radnika--;
        pthread_cond_signal(&condFarbanje);
        pthread_mutex_unlock(&mutexFarbanje);

        printf("Ja sam deo %ld, cekam na susenje sloja %d\n", i, j);
        pthread_mutex_lock(&mutexSusenje);
        while(br_delova_u_susari >= X) pthread_cond_wait(&condSusenje, &mutexSusenje);
        br_delova_u_susari++;
        pthread_mutex_unlock(&mutexSusenje);

        printf("Ja sam deo %ld, krecem sa susenjem sloja %d\n", i, j);
        sleep(S);
        printf("Ja sam deo %ld, zavrsio sam sa susenjem sloja %d\n", i, j);

        pthread_mutex_lock(&mutexSusenje);
        br_delova_u_susari--;
        pthread_cond_signal(&condSusenje);
        pthread_mutex_unlock(&mutexSusenje);
    }
    printf("Ja sam deo %ld, zavrsio sam sa farbanjem\n", i);
}

int main() 
{
    pthread_t threads[N];
    pthread_mutex_init(&mutexFarbanje, NULL);
    pthread_mutex_init(&mutexSusenje, NULL);
    pthread_cond_init(&condFarbanje, NULL);
    pthread_cond_init(&condSusenje, NULL);

    for(long i = 0; i < N; i ++)
    {
        pthread_create(threads + i, NULL, farbanje, (void *) i);
    }

    for(long i = 0; i < N; i ++)
    {
        pthread_join(threads[i], NULL);
    }

    return 0;
}