#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<time.h>
#include<pthread.h>
//dva radnikai susara-> deljeni resurs

#define SUSARA 2
#define N 4
//deo koji se farba stize za p sekundi
//deo koji se farma ima SLOJ koji se nanosi za p sekundi
//
pthread_mutex_t farba;
pthread_mutex_t sus;
pthread_cond_t susenje;
pthread_cond_t farb;
int susara=0;
int radnik=2;
pthread_mutex_t radn;
void *farbara(void *idd)
{
    long id = (long)idd;
    long povrsina = (long)idd;
    long slojFarbe = (long)idd;
    while(1)
    {
        if(povrsina>0)
        {

            sleep(id);
            printf("Deo %ld stize u farbaru\n",id);
            
            
            if(radnik>0 && radnik<=2)
            {
                radnik--;
                printf("Radnik %d farba deo %ld\n",radnik+1,id);
                pthread_mutex_lock(&radn);
                pthread_mutex_lock(&farba);
                sleep(id);
                povrsina--;
                printf("Deo %ld povrsina %ld je ofarbana\n",id,povrsina+1);
                pthread_mutex_unlock(&farba);
            }

            else
            {  
                printf("Deo %ld ceka radnika\n",id);
                pthread_cond_wait(&farb,&farba);
            }
            pthread_mutex_unlock(&radn);
            
            pthread_cond_broadcast(&susenje);
            pthread_cond_broadcast(&farb);
            printf("Radnik %d je zavrsio farbanje dela %ld\n",radnik+1,id);
            radnik++;
        }
        else
        {
            printf("Deo %ld je zavrsio\n",id);
            pthread_mutex_unlock(&farba);
                break;
        }



        susara++;
        printf("Deo %ld je usao u susaru\n",id);
        
         pthread_mutex_lock(&sus);
            if(susara<SUSARA)
            {

               
                sleep(id);
                printf("Deo %ld povrsina %ld je osusena\n",id,povrsina+1);
                susara--;
                pthread_mutex_unlock(&sus); 
            }
            else
            {
                printf("Deo %ld cekam da se susim\n",id);
                pthread_cond_wait(&susenje,&sus);

                printf("Deo %ld dosao je na mene red da se susim\n",id);
                pthread_mutex_unlock(&sus); 
            }
            

        
        
    }
    pthread_exit(NULL);
}

int main()
{
    pthread_t delovi[N];
    pthread_mutex_init(&sus,NULL);
    pthread_mutex_init(&farba,NULL);
    pthread_cond_init(&susenje,NULL);
    pthread_cond_init(&farb,NULL);
    pthread_mutex_init(&radn,NULL);
    long i;
    for(i=0;i<N;i++)
    {
        pthread_create(delovi+i,NULL,farbara,(void *)i+1);
    }
       


    for(i=0;i<N;i++)
        pthread_join(delovi[i],NULL);

    return 0;
}