#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<pthread.h>

#define broj_radnika 2
#define broj_delova 20
#define s 3
#define x 4

typedef struct deo{
    long id;
    int p;
    int k;
}Deo;

pthread_mutex_t mutex;
pthread_cond_t cond;
int susaraZauzeto[4];
int radnikJedanZauzet=0;
int radnikDvaZauzet=0;
int deoCeka1=0,deoCeka2=0;
int ceka_susenje=0;
int uSusari=0;

void * func(void * arg){
    long id1=(long)arg;
    Deo *deo=(Deo*)malloc(sizeof(Deo));
    deo->id=id1;
    deo->p=(rand()%5)+1;
    deo->k=(rand()%3)+1;
    int t=rand()%10;
    sleep(t);
    int radnik=rand()%2;
    int vreme_spavanja=deo->k*deo->p;
    if(radnik==0){
        //preuzima ga prvi radnik i nanosi slojeve farbe na deo
        pthread_mutex_lock(&mutex);
        while(radnikJedanZauzet>0 || deoCeka1>0){
            pthread_cond_wait(&cond,&mutex);
        }
        deoCeka1++;
        printf("RADNIK 1:Deo %ld je stigao na red za farbanje\n",deo->id);
        deoCeka1--;
        radnikJedanZauzet++;
        pthread_mutex_unlock(&mutex);
        //radnik nanosi k*p slojeva
        //znaci sleep je k*p
        sleep(vreme_spavanja);
        printf("RADNIK1:Deo %ld je ofarban sa %d slojeva za vreme %d\n",deo->id,deo->k,vreme_spavanja);
        pthread_mutex_lock(&mutex);
        radnikJedanZauzet--;
        printf("RADNIK1:Deo %ld je zavrsio i sada krece na susenje\n",deo->id);
        ceka_susenje++;
        pthread_cond_broadcast(&cond);
        pthread_mutex_unlock(&mutex);
        //sada ide u susaru

    }
    else{
        //preuzima ga drugi radnik
        pthread_mutex_lock(&mutex);
        while(radnikDvaZauzet>0 || deoCeka2>0){
            pthread_cond_wait(&cond,&mutex);
        }
        deoCeka2++;
        printf("RADNIK 2:Deo %ld je stigao na red za farbanje\n",deo->id);
        deoCeka2--;
        radnikDvaZauzet++;
        pthread_mutex_unlock(&mutex);
        //radnik nanosi k*p slojeva
        //znaci sleep je k*p
        sleep(vreme_spavanja);
        printf("RADNIK 2:Deo %ld je ofarban sa %d slojeva za vreme %d\n",deo->id,deo->k,vreme_spavanja);
        pthread_mutex_lock(&mutex);
        radnikDvaZauzet--;
        printf("RADNIK 2:Deo %ld je zavrsio i sada krece na susenje\n",deo->id);
        ceka_susenje++;
        pthread_cond_broadcast(&cond);
        pthread_mutex_unlock(&mutex);
        //sada ide u susaru
        
    }
    pthread_mutex_lock(&mutex);
    while(ceka_susenje==0 || uSusari>=x ){
        pthread_cond_wait(&cond,&mutex);
    }
    ceka_susenje--;
    uSusari++;
    printf("SUSARA: Deo %ld se susi u susari\n",deo->id);
    pthread_mutex_unlock(&mutex);
    sleep(s);
    pthread_mutex_lock(&mutex);
    uSusari--;
    printf("SUSARA: Deo %ld se osusio i izlazi\n",deo->id);
    pthread_cond_broadcast(&cond);
    pthread_mutex_unlock(&mutex);
    
}
int main(){
    pthread_t t[broj_delova];
    pthread_mutex_init(&mutex,NULL);
    pthread_cond_init(&cond,NULL);
    for(long i=0;i<broj_delova;i++){
        pthread_create(t+i,NULL,func,(void*) i);
    }
    for(long i=0;i<broj_delova;i++){
        pthread_join(t[i],NULL);
    }
    return 0;
}