#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#DEF BROJ_RADNIKA 4

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cont_t cond = PTHREAD_COND_INITIALIZER;
int brojUSuselici = 0;

int x = rand() % 5; // kapacitet susare
int pi = rand() % 4; // povrsina
int ki = rand() % 5; // slojevi

void* farbanje( void* arg ){

    pthread_mutex_lock(&mutex);

    sleep(rand()% 10)

    printf("Krecem sa farbanjem!");

    while(brojUSuselici > x)
        pthread_cond_wait(&cond, &mutex);

    sleep(rand()% 10)

    pthread_cond_broadcast(&cond);

    pthread_mutex_unlock(&mutex);
}


int main(){

    pthread_t p[4];

    for(int i = 0; i<4; i++){
        pthread_init(&p[i], NULL, farbanje, NULL);
    }

    for(int i = 0; i<4; i++){
        pthread_join(&p[i], NULL);
    }

    pthread_mutex_destroy(&mutex);
    return 0;
}