#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
// broj delova
#define N 10
#define X 2

pthread_mutex_t mutexF;
pthread_mutex_t mutexS;
pthread_cond_t condF;
pthread_cond_t condS;

int r1 = 0, r2 = 0, susara = 0;

void* farbaj( void *arg )
{
    long index = ( long ) arg;

    //trenutak t 
    sleep( rand() % 10 );

    // odredjivanje povrsine, duzine farbanja i broj slojeva 
    int pi = rand() % 5 + 1;
    int s = rand() % 4 + 1 ;
    int k = rand() % 3 + 1 ;
    int radnik = 0;

    
    while(k > 0)
    {
        // FARBANJE
        printf("Deo %ld je stigao i farba se jos %d puta \n", index, k);

        pthread_mutex_lock( &mutexF );

        while(r1 > 0 && r2 > 0 )
            pthread_cond_wait( &condF, &mutexF );

        if(r1 == 0)
        {
            r1++;
            radnik = 1;
        }
        else
        {
            r2++;
            radnik = 2;
        }

        pthread_mutex_unlock( &mutexF );
        
        printf("Deo %ld se farba \n", index);
        sleep(pi);

        pthread_mutex_lock( &mutexF );

        if( radnik == 1 )
            r1--;
        else
            r2--;

        pthread_cond_broadcast( &condF );

        pthread_mutex_unlock( &mutexF );


        printf("Deo %ld je ofarban \n", index);


        // SUSENJE
        pthread_mutex_lock( &mutexS );

        while(susara >= X )
            pthread_cond_wait( &condS, &mutexS );

        susara++;

        pthread_mutex_unlock( &mutexS );

        printf("Deo %ld se susi \n", index);
        sleep(s);


        pthread_mutex_lock( &mutexS );

        susara--;
        pthread_cond_broadcast( &condS );

        pthread_mutex_unlock( &mutexS );
            
        printf("Deo %ld je osusen \n", index);

        // zbog ponovnog susenja
        k--;
    }
    printf("Deo %ld je ofarban, osusen i spreman za dalju obradu \n", index);
}

int main()
{

    pthread_t t[N];


    pthread_mutex_init( &mutexF, NULL);
    pthread_mutex_init( &mutexS, NULL);
    pthread_cond_init( &condF, NULL);
    pthread_cond_init( &condS, NULL);

    for( long i = 0; i < N; i++ )
    {
        pthread_create( t + i, NULL, farbaj, ( void * ) i );
    }
    
    for( int i = 0; i < N; i++ )
    {
        pthread_join( t[ i ], NULL);
    }

    return 0 ;
}