#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<time.h>
#include<pthread.h>

#define I 5
#define P 3
#define K 3
#define X 2
#define S 2

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond_worker1 = PTHREAD_COND_INITIALIZER;
pthread_cond_t cond_worker2 = PTHREAD_COND_INITIALIZER;
pthread_cond_t cond_susara = PTHREAD_COND_INITIALIZER;

int worker1_busy = 0;
int worker2_busy = 0;
int susara = 0;

void *worker1(void *arg) {
    long tid = (long) arg;
    int t = 1 + rand() % 10;
    int p = 1 + rand() % P;
    int k = 1 + rand() % K;
    int i = 0;

    sleep(t);
    printf("DEO %ld SLOJEVA %d STIGAO ZA %d sekundi\n", tid, k, t);

    while (k > i) {
        pthread_mutex_lock(&mutex);
        printf("\t--- RADNIK 1, STIZE DEO %ld, SLOJ %d\n", tid, i + 1);
        while(worker1_busy) {
            printf("\t--- RADNIK 1 JE ZAUZET, CEKA DEO %ld\n", tid);
            pthread_cond_wait(&cond_worker1, &mutex);
        }
        worker1_busy = 1;
        pthread_mutex_unlock(&mutex);

        printf("\t--- RADNIK 1, DEO %ld, SLOJ %d, FARBA %d sekundi\n", tid, i + 1, p);
        sleep(p);

        pthread_mutex_lock(&mutex);
        while(susara >= X) {
            printf("\tRADNIK 1 CEKA SUSARU, DEO %ld\n", tid);
            pthread_cond_wait(&cond_susara, &mutex);
        }
        worker1_busy = 0;
        susara++;
        pthread_cond_signal(&cond_worker1);
        pthread_mutex_unlock(&mutex);

        printf("\t--- DEO %ld, SLOJ %d, SUSI %d sekundi\n", tid, i + 1, S);
        sleep(S);

        pthread_mutex_lock(&mutex);
        printf("\t--- DEO %ld, SLOJ %d, ZAVRSIO SUSENJE\n", tid, i + 1);
        if(susara > 0) susara--;
        pthread_cond_broadcast(&cond_susara);
        pthread_mutex_unlock(&mutex);

        i++;
    }

    printf("!!! DEO %ld ZAVRSEN CEO PROCES\n", tid);

    pthread_exit(NULL);
}

void *worker2(void *arg) {
    long tid = (long) arg;
    int t = 1 + rand() % 10;
    int p = 1 + rand() % P;
    int k = 1 + rand() % K;
    int i = 0;

    sleep(t);
    printf("DEO %ld SLOJEVA %d STIGAO ZA %d sekundi\n", tid, k, t);

    while (k > i) {
        pthread_mutex_lock(&mutex);
        printf("\t--- RADNIK 2, STIZE DEO %ld, SLOJ %d\n", tid, i + 1);
        while(worker2_busy) {
            printf("\t--- RADNIK 2 JE ZAUZET, CEKA DEO %ld\n", tid);
            pthread_cond_wait(&cond_worker2, &mutex);
        }
        worker2_busy = 1;
        pthread_mutex_unlock(&mutex);

        printf("\t--- RADNIK 2, DEO %ld, SLOJ %d, FARBA %d sekundi\n", tid, i + 1, p);
        sleep(p);

        pthread_mutex_lock(&mutex);
        while(susara >= X) {
            printf("\t--- RADNIK 2 CEKA SUSARU, DEO %ld\n", tid);
            pthread_cond_wait(&cond_susara, &mutex);
        }
        worker2_busy = 0;
        susara++;
        pthread_cond_signal(&cond_worker2);
        pthread_mutex_unlock(&mutex);

        printf("\t--- DEO %ld, SLOJ %d, SUSI %d sekundi\n", tid, i + 1, S);
        sleep(S);

        pthread_mutex_lock(&mutex);
        printf("\t--- DEO %ld, SLOJ %d, ZAVRSIO SUSENJE\n", tid, i + 1);
        if(susara > 0) susara--;
        pthread_cond_broadcast(&cond_susara);
        pthread_mutex_unlock(&mutex);

        i++;
    }

    printf("!!! DEO %ld ZAVRSEN CEO PROCES\n", tid);

    pthread_exit(NULL);
}

int main() {
    srand(time(NULL));
    pthread_t threads[2];
    long i = 0;
    printf("SVAKI DEO STIZE U T VREMENSKOM TRENUTKU\n\n");
    for(i = 0; i < I; i++) {
        if(i % 2 == 0) pthread_create(&threads[i], NULL, worker1, (void *)i);
        else pthread_create(&threads[i], NULL, worker2, (void *)i);
    }
    for(i = 0; i < I; i++) pthread_join(threads[i], NULL);

    pthread_exit(NULL);
}