#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include<unistd.h>

int N = 10; //broj delova
int p = 4; //povrsina dela
int k = 4; //broj slojeva farbe
int k1 = 0; //broj obojenih slojeva

int k2 = 0; //broj osusenih slojeva

int x = 5; //kapacitet susare
int brojDelovaSusara=0; //broj delova u susari
int s=3;//broj sekundi u susari

pthread_mutex_t mutex;
pthread_mutex_t mutex2;
pthread_cond_t condFarbanje, condSusenje;

void *farbanje(void* arg)
{
    long id = (long)arg;
    sleep(rand()%3);
    printf("Deo %ld je stigao u farbaru\n", id);
    while(k1<k)
    {
        pthread_mutex_lock(&mutex);
        while(k1 != k2) pthread_cond_wait(&condFarbanje, &mutex);

        int sloj = ++k1;
        pthread_mutex_unlock(&mutex);
        printf("Na deo %ld, nanosi se %d sloj\n",id,sloj);
        sleep(p);

        pthread_mutex_lock(&mutex);
        pthread_cond_signal(&condSusenje);
        pthread_mutex_unlock(&mutex);
    }
    
}

void *susenje(void* arg)
{
    long id = (long)arg;
    sleep(rand()%3);
    printf("Deo %ld je stigao u susaru\n", id);
    while(1)
    {
        pthread_mutex_lock(&mutex);
        while(brojDelovaSusara>=x && k1==k2) pthread_cond_wait(&condSusenje, &mutex);

        brojDelovaSusara++;
        int sloj = ++k2;
        pthread_mutex_unlock(&mutex);
        printf("Deo %ld je na susenju %d sloja\n", id,sloj);
        sleep(s);

        pthread_mutex_lock(&mutex);
        brojDelovaSusara--;
        if(k1==k2) pthread_cond_signal(&condFarbanje);
        else pthread_cond_broadcast(&condSusenje);
        pthread_mutex_unlock(&mutex);
    }
}

int main()
{
    pthread_t t[N];

    pthread_mutex_init(&mutex,NULL);
    pthread_mutex_init(&mutex2,NULL);
    pthread_cond_init(&condFarbanje,NULL);
    pthread_cond_init(&condSusenje,NULL);
    for(int i=0;i<N;i++){
        pthread_create(&t[i],NULL,farbanje,(void*)i);
    }
    for(int i=0;i<N;i++){
        pthread_create(&t[i],NULL,susenje,(void*)i);
    }
    for(int i=0;i<N;i++){
        pthread_join(t[i],NULL);
    }
    return 0;
}