#include<stdio.h>
#include<pthread.h>
#include<unistd.h>

#define X 2
#define N 5
#define radnici 2
#define susenje 3


int kapacitet_radnici=0;
int kapacitet_susara=0;

pthread_mutex_t mutex;
pthread_cond_t cond;
pthread_cond_t cond_susara;
int ofarbano = 0;

void *doWork(void *t) {

    long id = (long *)t;
    int k = rand()%10;
    int p = rand()%10;
    printf("Treba deo id=%ld povrsine %d ofarbati %d puta\n",id,p,k);

    for(int i=0;i<k;i++) {

        //farbanje

        pthread_mutex_lock(&mutex);
        while(kapacitet_radnici==radnici) {
            pthread_cond_wait(&cond, &mutex);
        }
        kapacitet_radnici++;
        pthread_mutex_unlock(&mutex);


        printf("Farbam deo id=%ld %d. put %d sec\n", id,i+1,p);
        sleep(p);

        pthread_mutex_lock(&mutex);
        kapacitet_radnici--;
        pthread_mutex_unlock(&mutex);
        pthread_cond_broadcast(&cond);



        //susenje

        pthread_mutex_lock(&mutex);
        while(kapacitet_susara==X) {
            pthread_cond_wait(&cond_susara, &mutex);
        }
        kapacitet_susara++;
        pthread_mutex_unlock(&mutex);


        printf("Susim deo id=%ld %d. put %d sec\n", id,i+1,susenje);
        sleep(susenje);

        pthread_mutex_lock(&mutex);
        kapacitet_susara--;
        pthread_mutex_unlock(&mutex);
        pthread_cond_broadcast(&cond_susara);
    }


}


void main() {

    pthread_t thread[N];

    pthread_mutex_init(&mutex, NULL);
    pthread_cond_init(&cond, NULL);
    pthread_cond_init(&cond_susara, NULL);



    for(int i=0;i<N;i++) {
        pthread_create(&thread[i], NULL, doWork, (void *)i);
    }




    pthread_exit(NULL);
}
