#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<pthread.h>

pthread_mutex_t mutex;
pthread_mutex_t mutexSusenje;
pthread_cond_t susenjeCond;
pthread_cond_t farbanjeCond;

int brDelova=7;
int susaraCap=3;
int vremeSusenja=3;


int brOfarbanih=0;
int brOsusenih=0;
int brFarbajuSe=0;
int brSuseSe=0;

// void stampanjeStanja()
// {
//     printf("%d ofarbana dela, %d osusena dela, %d trenutno se farbaju, %d trenutno se suse\n");
// }

void * farbajISusi(void *arg)
{
    long id = (long)arg;
    int sloj=rand()%3+1;//k
    int p=rand()%2+1;
    
    pthread_mutex_lock(&mutex);
    printf("deo %ld je spreman za farbanje\n", id);
    for(int i=1; i<=sloj; i++)
    {
        while(brFarbajuSe>=2)
        {
            pthread_cond_wait(&farbanjeCond, &mutex);
        }
        brFarbajuSe++;
        pthread_mutex_unlock(&mutex);
        pthread_mutex_lock(&mutex);
        printf("sloj %d dela %ld se farba\n", i, id);
        sleep(p);
        brFarbajuSe--;
        printf("sloj %d dela %ld je ofarban\n", i, id);
        pthread_mutex_unlock(&mutex);
        pthread_cond_broadcast(&farbanjeCond);
        pthread_mutex_lock(&mutexSusenje);
        while(brSuseSe>=susaraCap)
        {
            pthread_cond_wait(&susenjeCond, &mutexSusenje);
        }
        brSuseSe++;
        pthread_mutex_unlock(&mutexSusenje);
        pthread_mutex_lock(&mutexSusenje);
        printf("sloj %d dela %ld se susi\n", i, id);
        sleep(vremeSusenja);
        brSuseSe--;
        printf("sloj %d dela %ld je osusen\n", i, id);
        pthread_mutex_unlock(&mutexSusenje);
        pthread_cond_broadcast(&susenjeCond);

    }
    printf("deo %ld ofarban i osusen\n", id);
    // brOfarbanih++;

    



}
int main()
{
    pthread_t delovi[brDelova];
    pthread_mutex_init(&mutex, NULL);
    pthread_cond_init(&susenjeCond, NULL);
    pthread_cond_init(&farbanjeCond, NULL);

    for(long i=0; i< brDelova; i++)
    {
        pthread_create(&delovi[i], NULL, farbajISusi, (void*)i);
    }
    for(long i=0; i<brDelova; i++)
    {
        pthread_join(delovi[i], NULL);
    }

    pthread_mutex_destroy(&mutex);
    pthread_cond_destroy(&mutex);
}