#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include<limits.h>
#include<unistd.h>
#include<pthread.h>

#define N 10
#define X 2 //MESTA U SUSARI
#define S 2 // SVAKI SLOJ SE SUSI 2 SEKUNDE



pthread_mutex_t Mutex;
pthread_mutex_t MutexDva;
pthread_mutex_t farbaraMutex;
pthread_mutex_t susaraMutex;
pthread_cond_t CekaFarbanjeCond;
pthread_cond_t SpremanZaSusenjeCond;

int brojJedan=0;
int brojDva=0;
int cekaSusenje = 0;
int uSusari = 0;
int cekaFarbanje = 0;


void *farbanje(void *arg)
{
    long tid = (long)arg;
    int sTime = rand()%15; 
    int povrsina = rand()%2 + 1;
    int brSlojeva = rand()%3 + 1;
    int farbamSe=1;
    int slobodno = 2;
    

    printf("Deo %ld je dosao u trenutku %d i spreman je za farbanje\n",tid,sTime);

    while(brSlojeva>0)
    {
        pthread_mutex_lock(&farbaraMutex);
        cekaFarbanje++;
        
        while(brojJedan && brojDva && slobodno>0)
            pthread_cond_wait(&CekaFarbanjeCond,&farbaraMutex);
        
        slobodno--;
        cekaFarbanje--;
        pthread_mutex_unlock(&farbaraMutex);
        
        if(brojJedan == 0) 
        {
            pthread_mutex_lock(&Mutex);
            printf("Radnik broj Jedan farba deo %ld \n",tid);
            brojJedan = 1;
            sleep(povrsina);
            brSlojeva--;
            brojJedan = 0;
            pthread_cond_broadcast(&CekaFarbanjeCond);
            printf("Radnik broj Jedan je ofarbao deo %ld i on ceka susenje\n",tid);
            pthread_mutex_unlock(&Mutex);
            
        }
        else
        {
            pthread_mutex_lock(&MutexDva);
            printf("Radnik broj Dva farba deo %ld \n",tid);
            brojDva = 1;
            sleep(povrsina);
            brSlojeva--;
            brojDva = 0;
            pthread_cond_broadcast(&CekaFarbanjeCond);
            pthread_mutex_unlock(&MutexDva);
            printf("Radnik broj Dva je ofarbao deo %ld i on ceka susenje\n",tid);
            printf("Deo %ld ceka susenje\n",tid);
            
        }

        pthread_mutex_lock(&susaraMutex);
        cekaSusenje++;
        while(uSusari >= X)
            pthread_cond_wait(&SpremanZaSusenjeCond,&susaraMutex);

        cekaSusenje--;
        uSusari++;
        pthread_mutex_unlock(&susaraMutex);

        printf("Deo %ld krece da se susi\n",tid);
        sleep(S);
        printf("Deo %ld se osusio\n",tid);

        pthread_mutex_lock(&susaraMutex);
        uSusari--;
        pthread_cond_broadcast(&SpremanZaSusenjeCond);
        pthread_mutex_unlock(&susaraMutex);
    }
    

}

int main()
{
    pthread_t threads[N];

    pthread_cond_init(&SpremanZaSusenjeCond,NULL);
    pthread_cond_init(&CekaFarbanjeCond,NULL);
    pthread_mutex_init(&farbaraMutex,NULL);
    pthread_mutex_init(&susaraMutex,NULL);
    pthread_mutex_init(&Mutex,NULL);
    pthread_mutex_init(&MutexDva,NULL);


    for(long i=0; i<N; i++)
    {
        pthread_create(threads + i, NULL, farbanje, (void*) i);
    }

    for(long i=0; i<N; i++)
    {
        pthread_join(threads[i], NULL);
    }

    return 0;
}