#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

#define x 3
#define s 2
#define DELOVI 10

pthread_mutex_t mutexSusara = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t mutexFarbara = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t condSusara = PTHREAD_COND_INITIALIZER;

int brUSusari = 0;

void *delovi(void *arg)
{
	long tid = (long) arg;
	
	int t = 1 + rand() % 10;
	int k = 1 + rand() % 10;
	int trenutnoSlojeva = 0;	
	int p = 1 + rand() % 10;	
	
	sleep(t);
	printf("Deo %ld dolazi na farbanje posle %ds \n", tid, t);

	while(trenutnoSlojeva < k)
	{
		pthread_mutex_lock(&mutexFarbara);

		trenutnoSlojeva++;
		
		printf("Deo %ld se farba, trenutno slojeva: %d od %d, povrsina: %d \n", tid, trenutnoSlojeva, k, p);
		pthread_mutex_unlock(&mutexFarbara);
		
		sleep(p);		
		
		printf("Deo %ld odlazi na susenje. \n", tid);		

		pthread_mutex_lock(&mutexSusara);

		while(brUSusari == x)
			pthread_cond_wait(&condSusara, &mutexSusara);

		brUSusari++;
		
		printf("Deo %ld se susi %ds. Trenutno se suse: %d\n",tid, s, brUSusari);

		pthread_mutex_unlock(&mutexSusara);
		
		sleep(s);

		pthread_mutex_lock(&mutexSusara);

		brUSusari--;
	
		pthread_cond_broadcast(&condSusara);

		pthread_mutex_unlock(&mutexSusara);

	}

	printf("DEO %ld JE OFARBAN! \n", tid);

	pthread_exit(NULL);
}

int main()
{
	pthread_t delovi_threads[DELOVI];
	
	srand(time(NULL));

	for(long i = 0; i < DELOVI; i++)
		pthread_create(&delovi_threads[i], NULL, delovi, (void*)i);

	pthread_exit(NULL);

}
