#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

#define N 10

int p[N],k[N];
int susaraStatus[N];
int x = 4, s = 2;

int stanje = 0;

int index = 0;

pthread_mutex_t mutexSusara;
pthread_mutex_t mutex[N];

pthread_cond_t condSusara;
pthread_cond_t cond[N];

void *funcF(void *arg)
{
    long time = (long) arg;

    sleep(time);

    while(1)
    {
        pthread_mutex_lock( mutex + index );

        while( stanje == x
        && k[ index ] != 0 
        && susaraStatus[ index ] != 0 
        && pthread_cond_wait( 
            cond + index, 
            mutex + index  
        ));

        if( k[ index ] == 0 )
            k[index]--;

        susaraStatus[ index ] = 1;

        printf( "Ofarban je deo %d\n", index );

        stanje++;

        index++;

        if(index == N)
            index = 0;
        
        sleep(p[index]);

        pthread_mutex_unlock( mutex + index ); 

        pthread_cond_signal( cond + index );
        if(stanje == x)
            pthread_cond_signal( &condSusara );
    }
}

void *funcS(void *arg)
{

    while(1)
    {
        pthread_mutex_lock( &mutexSusara );

        while(stanje != x 
        && pthread_cond_wait( 
            &condSusara, 
            &mutexSusara
        ));

        sleep(s);

        for(int i = 0 ; i < N ; i++)
            if( susaraStatus[ i ] )
                printf( "Susi se deo: %d\n", i );

        for(int i = 0 ; i < N ; i++)
            susaraStatus[ i ] = 0;

        stanje = 0;

        pthread_mutex_unlock( &mutexSusara );

        //pthread_cond_broadcast();
    }
}

int main()
{

    pthread_t farbanje[2];
    pthread_t susenje;

    for(int i = 0 ; i < 2 ; i++)
    {
        pthread_create(farbanje + i, NULL, funcF, (void*) i);
    }

    for(int i = 0; i < N ; i++)
    {
        p[i] = k[i] = i + 1;
    }

    for(int i = 0 ; i < 2 ; i++)
    {
        pthread_join(farbanje[i], NULL);
    }

    pthread_join( &susenje, NULL);

    return 0;
}