#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include<time.h>

pthread_mutex_t mutex;
pthread_cond_t uslov;

typedef struct{
    long id;
    int p;
    int k;
}Deo;

int x=3; //kapacitet susare
int s=2;//svaki deo ide u susaru na s sekundi
int brojRadnika=0;
int t=2;//vremenski trenutak kad deo stize u farbaru

void *farbanjeFunkcija(void *arg)
{
    Deo *d=(Deo *)arg;
    sleep(t);
    printf("Deo %ld je stigao u farbaru!\n",d->id);

    for(int i=0;i<d->k;i++)
    {
        pthread_mutex_lock(&mutex);
        while(brojRadnika==2)
        {
            pthread_cond_wait(&uslov,&mutex);
        }
        brojRadnika++;
        pthread_mutex_unlock(&mutex);
        
        printf("Radnik:Nanosim sloj farbe na deo:%ld koji treba da se prefarba:%d\n",d->id,d->k);
        sleep(d->p);
        pthread_mutex_lock(&mutex);
        brojRadnika--;
        pthread_cond_broadcast(&uslov);
        while(!x)
        {
            pthread_cond_wait(&uslov,&mutex);
        }
        x--;
        pthread_mutex_unlock(&mutex);

        printf("Susara:Vrsim susenje sloja farbe dela:%ld\n",d->id);
        sleep(s);

        pthread_mutex_lock(&mutex);
        //brojRadnika--;
        x++;
        pthread_cond_broadcast(&uslov);
        pthread_mutex_unlock(&mutex);

    }

    
    


}

int main()
{
    pthread_mutex_init(&mutex,NULL);
    pthread_cond_init(&uslov,NULL);
    pthread_t delovi[5];

    for(long i=0;i<5;i++)
    {
        Deo *d=(Deo *)malloc(sizeof(Deo));
        d->id=i;
        d->p=(rand()%4)+1;
        d->k=(rand()%3)+1;
        pthread_create(&delovi[i],NULL,farbanjeFunkcija,(void *)d);
    }

    for(long i=0;i<5;i++)
    {
        pthread_join(delovi[i],NULL);
    }

    return 0;

}