#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<pthread.h>
 
#define brojDelova 10
#define kapacitetSusare 5


int zauzetostSUsare = 0; // 5 delova moze da se susi odjednom
int farberi[2] = { 0, 0}; // na pocetku oba radnika su slobodna; 0 - ne farba 1 - farba
pthread_mutex_t mutex;
pthread_cond_t cond;



void *farbajSusi(void *arg){
    long i = (long) arg + 1;
    int povrsina = rand() % 5 + 1;
    int slojevaFarbe = rand() % 3 + 1; // 1,2 ili 3 sloja farbe
    int slojFarbeKojiSeFarba = 1; // trenutni sloj koji se farba

    sleep(rand() % 4);



    if(slojFarbeKojiSeFarba <= slojevaFarbe){
    
        printf(" Deo %ld, povrsine %d i broj slojeva farbe %d.\n", i, povrsina, slojevaFarbe );
        
        pthread_mutex_lock(&mutex);


        // printf("%d  ", farberi[0]);
        // printf("%d  ", farberi[1]);
        // printf("%d  ", kapacitetSusare);

        
        //cim se nanese SLOJ farbe pokusa da odmah ide u susaru da se susi
        //cekam dok se oslobodi mesto da me farba ili ako sam ofarban i ima mesta da idem u susaru
        // 5 nema mesta u susari
        while((farberi[0]!=0 || farberi[1]!=0) || zauzetostSUsare == kapacitetSusare){
            // printf("usao u while\n"); //radi provere 
            pthread_cond_wait(&cond, &mutex);

        }
            

        int farberKojiMeFarba = 0; //definisano radi lakseg snalazenja, neka je 0 difoltni
        //farba prvi farber koji je slobodan
        if(farberi[0] == 0 && farberi[1]==1){
            farberi[0] = 1;
            farberKojiMeFarba = 0;
        } 
        else if (farberi[0] == 1 && farberi[1]==0){
            farberi[1] = 1;
            farberKojiMeFarba = 1;
        }
        else farberi[0] == 1;

        //farbanje
        sleep(povrsina);
        printf(" Deo %ld, se farba po %d put.\n", i, slojFarbeKojiSeFarba);


        //ide u susaru znaci smanjuje mesta tamo
        //OVDE NESTO TREBA DODATI OKO SUSENJA!!
        printf(" Deo %ld, se susi.\n", i);
        sleep(rand()% 3); //susi se nekih s sekundi
        zauzetostSUsare --;

        pthread_mutex_unlock(&mutex);

        printf(" Deo %ld, ofarban %d sloj od ukupno %d slojeva i osusio se.\n", i, slojFarbeKojiSeFarba, slojevaFarbe);

        pthread_mutex_lock(&mutex);

        farberi[farberKojiMeFarba] = 0; // oslobadjam farbera
        zauzetostSUsare ++; // povecavam kapacitet jer sam osusen
        pthread_cond_broadcast(&cond);
        pthread_mutex_unlock(&mutex);

        slojFarbeKojiSeFarba ++; // ofarban i osusen taj sloj sad ide sledeci

    }else{
        printf ( " Deo %ld ofarban.\n", i);
    }

}


int main(){

    pthread_t threads[brojDelova];
    pthread_mutex_init(&mutex, NULL);
    pthread_cond_init(&cond, NULL);


    for(long i = 0; i<brojDelova; i++){
        pthread_create(threads+i, NULL, farbajSusi, (void*) i);
    }

    for(long i = 0; i<brojDelova; i++){
        pthread_join(threads[i], NULL);
    }

    pthread_mutex_destroy(&mutex);

    return 0;
}